//+------------------------------------------------------------------+ 
//|   TRO_PriceOccurs                                                | 
//|                                                                  | 
//|   Copyright  2011, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2011, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0


//---- indicator parameters  

extern bool SHOW.PRICE = true ; 

extern int win            = 0 ;
extern int CORNER         = 0 ;
extern int price.x.offset = 0 ;//250
extern int price.y.offset = 0 ;//-160


//extern double   price        = 0 ;
//extern int      tolerance    = 0 ;

extern int   Chart_Period    = 0;
extern int   myBars          = 0 ; // 1920 
extern color Up_color    = Lime;
extern color Eq_color    = Yellow;
extern color Dn_color    = Red;
extern color Price_color = Blue;

extern color highColor = LightSteelBlue ;
extern color lowColor  = LightSteelBlue ;

color ClOpColor ;

string symbol,tLabel01, tLabel02, tLabel03, tLabel04, tLabel05, tLabel06 ,TAG ;

double open   ;    
double close    ; 

double point,high, low, pcthigh, pctlow, pricehigh, pricelow ; 

int digits, recent, distant, occurs,  occursHI, occursLO ;

//+------------------------------------------------------------------+
color fColor( double i, double j)
{
color rColor ;

    if ( i > j ) rColor = Up_color; 
    else {
    if ( i < j )  rColor = Dn_color; 
    else rColor = Eq_color; }
return ( rColor );
}
 

//+------------------------------------------------------------------+ 

int init() 
{ 

  if(Chart_Period == 0) { Chart_Period = Period() ; }
   
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   

TAG = "PRC" ;

tLabel01 = "PRCO29" + Chart_Period + myBars + Symbol();
tLabel02 = "PRCO30" + Chart_Period + myBars + Symbol();
tLabel03 = "PRCO31" + Chart_Period + myBars + Symbol();
tLabel04 = "PRCO32" + Chart_Period + myBars + Symbol();
tLabel05 = "PRCO35" + Chart_Period + myBars + Symbol();
tLabel06 = "PRCO36" + Chart_Period + myBars + Symbol();

   deinit();
   return(0); 
} 


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
  
   ObDeleteObjectsByPrefix(TAG);  
   
      TRO() ;
   
   return(0);
}

 
//+------------------------------------------------------------------+ 
int start() 
{ 
 
double highi ; 
double lowi ;    
int limit; 

open   = iOpen(NULL,Chart_Period,0) ;  
close  = iClose(NULL,Chart_Period,0) ; 
close  = NormalizeDouble(close,digits) ;

ClOpColor = fColor( close, open ) ; 


pricehigh = iHigh(NULL,Chart_Period,0) ; 
pricelow  = iLow(NULL,Chart_Period,0) ; 

high    = 0 ;
low     = 0 ;
recent  = 0 ; 
distant = 0 ; 
occurs  = 0 ;
occursHI = 0;
occursLO = 0 ;

if(myBars == 0) { limit = WindowBarsPerChart() ;  } else { limit = myBars ; }
 
for(int i=1; i<=limit; i++) 
{ 

   highi = iHigh(NULL,Chart_Period,i) ; 
   highi = NormalizeDouble(highi,digits) ;
   
   lowi  = iLow(NULL,Chart_Period,i) ;  
   lowi  = NormalizeDouble(lowi,digits) ;
    
   if( close  >= lowi && close <= highi ) 
   {
      occurs  = occurs + 1  ;
      distant = i ; 
      if(recent == 0) { recent = i ; }      
   }

   if( close == highi ) 
   {
      occursHI  = occursHI + 1  ; 
   }
   
   if( close == lowi ) 
   {
      occursLO  = occursLO + 1  ; 
   }
} 


string tPeriod = " "+TimeFrameToString( Chart_Period ) ;

string tMsg1  =  " Recent Bar(" +  recent + ")"  ;
string tMsg2  =  " Distant Bar(" + distant + ")"  ;

string tPrice =  symbol + " " + DoubleToStr(close, digits ) + tPeriod   ;
string tMsg3  =  " Occurred " + occurs + "/" + limit + " times"  ;
string tMsgHI =  " Occurred High " + occursHI +   " times"  ;                     
string tMsgLO =  " Occurred Low " + occursLO +   " times"  ;                     
                     
   ObjectCreate(tLabel01, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel01,tMsg1, 15, "Arial Bold", highColor );
   ObjectSet(tLabel01, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel01, OBJPROP_XDISTANCE, 0+price.x.offset);
   ObjectSet(tLabel01, OBJPROP_YDISTANCE, 14+price.y.offset);


   ObjectCreate(tLabel04, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel04,tMsg2, 15, "Arial Bold", lowColor );
   ObjectSet(tLabel04, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel04, OBJPROP_XDISTANCE, 0+price.x.offset);
   ObjectSet(tLabel04, OBJPROP_YDISTANCE, 37+price.y.offset);  

  if(SHOW.PRICE)
  {      
   ObjectCreate(tLabel03, OBJ_LABEL, win, 0, 0);
   ObjectSetText(tLabel03, tPrice , 30, "Arial Bold", ClOpColor );
   ObjectSet(tLabel03, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel03, OBJPROP_XDISTANCE, 0+price.x.offset); // 765
   ObjectSet(tLabel03, OBJPROP_YDISTANCE, 60+price.y.offset); 
  }

   ObjectCreate(tLabel02, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel02,tMsg3, 15, "Arial Bold", lowColor );
   ObjectSet(tLabel02, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel02, OBJPROP_XDISTANCE, 0+price.x.offset);
   ObjectSet(tLabel02, OBJPROP_YDISTANCE, 100+price.y.offset); 
                                        

   ObjectCreate(tLabel05, OBJ_LABEL, win, 0, 0);
   ObjectSetText(tLabel05, tMsgHI , 15, "Arial Bold", highColor );
   ObjectSet(tLabel05, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel05, OBJPROP_XDISTANCE, 0+price.x.offset); // 765
   ObjectSet(tLabel05, OBJPROP_YDISTANCE, 123+price.y.offset);   
           
   ObjectCreate(tLabel06, OBJ_LABEL, win, 0, 0);
   ObjectSetText(tLabel06, tMsgLO, 15, "Arial Bold", lowColor );
   ObjectSet(tLabel06, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel06, OBJPROP_XDISTANCE, 0+price.x.offset); // 765
   ObjectSet(tLabel06, OBJPROP_YDISTANCE, 146+price.y.offset);  
    
   WindowRedraw();    
 
//} 


   return(0); 
} 

//+------------------------------------------------------------------+

 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
  

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
 
//+------------------------------------------------------------------+   